#include "libcom.h"
#include "libthrd.h"
#include <stdio.h>
#include <stdlib.h>
#include <unistd.h>
#include <stddef.h>
#include <fcntl.h>
#include <netdb.h>
#include <string.h>
#include <sys/types.h>
#include <sys/socket.h>
#include <sys/stat.h>
#include <netinet/in.h>
#include <netinet/tcp.h>
#include <arpa/inet.h>
#include <fcntl.h>

/** Constantes **/
#define MAX_LIGNE 2048
#define MAX_TAMPON 1024
#define MAX_UDP_MESSAGE 256

/** Variables publiques **/

/** Variables statiques **/

/** Procedure principale **/

int adresse=0;


void commandeHELO(char *buffer, int s)
{
	char buffer_sortie[1024];
	sprintf(buffer_sortie, "250 Ok\r\n");
	printf("message du serveur:  %s", buffer_sortie);
	send(s, buffer_sortie, strlen(buffer_sortie), 0);	

}

void commandeMAIL(char *buffer, int s)
{

	char buffer_sortie[1024];

	char addr_expediteur[256];
    char *acc_ouvr,*acc_ferm;
    acc_ouvr=strchr(buffer,'<');
    acc_ferm=strchr(buffer,'>');
    int portee=acc_ferm-(acc_ouvr+1);
		                                         
    strncpy(addr_expediteur,(acc_ouvr+1),portee);
		                                         
	printf("Expediteur <%s>",addr_expediteur);
	sprintf(buffer_sortie, "250 Ok\r\n");
	printf("message du serveur:  %s", buffer_sortie);
	send(s, buffer_sortie, strlen(buffer_sortie), 0);
}

void commandeRCPT(char *buffer, int s)
{
	char buffer_sortie[1024];
    sprintf(buffer_sortie, "250 Ok recipient\r\n");
	printf("message du serveur:  %s", buffer_sortie);
	send(s, buffer_sortie, strlen(buffer_sortie), 0);

}

void commandeDATA(char *buffer,  int s)
{
	char buffer_sortie[1024];	                                 
	sprintf(buffer_sortie, "354 Continue\r\n");
	printf("message du serveur:  %s", buffer_sortie);
	send(s, buffer_sortie, strlen(buffer_sortie), 0);
    if(strstr(buffer,"."))
    {
        //ENREGISTREMENT DES FICHIERS DE MESSAGE AINSI QUE LEUR STATUT
    }

}

void commandeQUIT(char *buffer,  int s)
{
	char buffer_sortie[1024];
	sprintf(buffer_sortie, "221 Quitting\r\n");
	printf("message du serveur:  %s", buffer_sortie);
	send(s, buffer_sortie, strlen(buffer_sortie), 0);

}


void commandeNOOP(char *buffer, int s)
{
	char buffer_sortie[1024];
	sprintf(buffer_sortie, "220  Service Ready\r\n");
	printf("message du serveur:  %s", buffer_sortie);
	send(s, buffer_sortie, strlen(buffer_sortie), 0);

}

void commandeRSET(char *buffer, int s)
{
	// FAIRE DES MEMSET SUR LES VARIABLES				
	char buffer_sortie[1024];
	sprintf(buffer_sortie, "250 Ok reset\r\n");
	printf("message du serveur:  %s", buffer_sortie);
	send(s, buffer_sortie, strlen(buffer_sortie), 0);

}



void redirection_Commandes(char *buffer, int s)
{
	int commande_digit=4; // CONSTANTE
    char buffer_sortie[1024];
    if(strncmp(buffer,"EHLO",commande_digit)==0 || strncmp(buffer,"HELO",commande_digit)==0)
		 commandeHELO(buffer,s);
    else if(strncmp(buffer,"MAIL",commande_digit)==0)
		 commandeMAIL(buffer,s);
    else if(strncmp(buffer,"RCPT",commande_digit)==0)
		 commandeRCPT(buffer,s);
    else if(strncmp(buffer,"DATA",commande_digit)==0)
		 commandeDATA(buffer,s);
    else if(strncmp(buffer,"RSET",commande_digit)==0)
		 commandeNOOP(buffer,s);
    else if(strncmp(buffer,"QUIT",commande_digit)==0)
		commandeQUIT(buffer,s);
	    else 
		{
			sprintf(buffer_sortie, "250 Ok\r\n");
			printf("message du serveur:  %s", buffer_sortie);
			send(s, buffer_sortie, strlen(buffer_sortie), 0);
		};

}


void gestionClientTCP(int s)
{
	/* Obtient une structure de fichier */
	FILE *dialogue=fdopen(s,"a+"); // acces à un fichier en mode lecture et écriture et append (ne pas écraser)
	if(dialogue==NULL){ perror("gestionClientTCP.fdopen"); exit(EXIT_FAILURE); }


    	char buffer[1024], buffer_sortie[1024];
    
        sprintf(buffer_sortie, "220 localhost ESMTP \r\n");
    	printf("%s", buffer_sortie);
    	send(s, buffer_sortie, strlen(buffer_sortie), 0);

	    while(fgets(buffer,MAX_LIGNE,dialogue)!=NULL)
	    {
		printf("message du client: %s", buffer);
		//scanf("%s",&message_serveur);
		//fprintf(dialogue,"message du serveur:  %s",ligne);
		redirection_Commandes(buffer,s);
	    }
 
	/* Termine la connexion */
	fclose(dialogue);
	#if DEBUG
	printf("client déconnecté\n");
	#endif

}


int multi_gestionClientTCP(int s)
{
	lanceThread(gestionClientTCP,(int) s,0);
	return 0;
}




int main(int argc,char *argv[])
{	
	int s=0; // METTRE EN VARIABLE GLOBALE
	char *machine="localhost"; //127.0.0.1
	char *port_loopback="2525"; // car 25 nécessite root  // METTRE EN CONSTANTE
	char *port_local="4444"; // METTRE EN CONSTANTE

	/* Initialisation du serveur */
	s=initialisationServeurTCP(port_local);

	/* Lancement de la boucle d'ecoute */
	boucleServeurTCP(s,multi_gestionClientTCP);

	/* On termine la connexion */
	shutdown(s,SHUT_RDWR);
}
